precision mediump float;

varying mediump vec4 v_color;
varying mediump vec2 v_uv;
varying mediump vec4 v_colorAdd;

uniform sampler2D u_texture;
uniform float ratio;
uniform vec3 u_outlineColor;
uniform vec2 u_fboBufferSize;

uniform mediump vec4 u_taps01;
uniform mediump vec4 u_taps23;
uniform mediump vec4 u_taps45;
uniform mediump vec4 u_taps67;
uniform mediump vec4 u_taps89;

void main()
{
	const float tapCount = 10.0;

	vec4 sum = vec4(0.0);
	sum += texture2D(u_texture, v_uv.xy + u_taps01.xy);
	sum += texture2D(u_texture, v_uv.xy + u_taps01.zw);
	sum += texture2D(u_texture, v_uv.xy + u_taps23.xy);
	sum += texture2D(u_texture, v_uv.xy + u_taps23.zw);
	sum += texture2D(u_texture, v_uv.xy + u_taps45.xy);
	sum += texture2D(u_texture, v_uv.xy + u_taps45.zw);
	sum += texture2D(u_texture, v_uv.xy + u_taps67.xy);
	sum += texture2D(u_texture, v_uv.xy + u_taps67.zw);
	sum += texture2D(u_texture, v_uv.xy + u_taps89.xy);
	sum += texture2D(u_texture, v_uv.xy + u_taps89.zw);
	
	// Black outline
	float lum = 1.0 - smoothstep(0.6, 0.95, 1.0 - sum.a / tapCount);
	
	gl_FragColor.r = lum * u_outlineColor.r;
	gl_FragColor.g = lum * u_outlineColor.g;
	gl_FragColor.b = lum * u_outlineColor.b;
	gl_FragColor.a = 1.0 - smoothstep(0.8, 1.0, 1.0 - sum.a / tapCount);
}
